/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package version005;

import java.util.Random;

/**
 *
 * @author Matko
 */
public class Kromosom {
    
    StringBuffer rasp = new StringBuffer();
    String newline=System.getProperty("line.separator");
    private int raspored[][]=new int[2][4];
    private int kofliktUcionica;
    private int kofliktTermin;
    private double fitness;
    
    /* generiranje rasporeda
     * 2 razreda, svaki piše tri ispita, 2 učionice na raspolaganju
     * 1. razred od 30 učenika
     * 2. razred od 25 učenika
     * matrica: stupci->vrijeme(npr. pon, uto, srijeda) 
     *          redovi-> učionice(jedna kapaciteta 30(prvi redak) 
                                    druga kapaciteta 25 (drugi redak))
     *
     * Ograničenja: razred smije pisati samo jedan ispit u danu
     *              razred mora pisati u onoj učionici predviđenoj za njeg  
     *              
     * 
     *legenda:  0->slobodan termin
     *          1-1.razred matematika
     *          2-1.razred engleski
     *          3-1.razred hrvatski
     *          4-2.razred matematika
     *          5-2.razred engleski
     *          6-2.razred hrvatski
     */ 
    
    public void StvoriRaspored (){
        
        Random r = new Random();
        int number1, number2, number3;
        int count=0;
        int spremnik[]=new int[6];
        int zastavica=0;
        
        
        /*  8 polja koja moramo popuniti, sva polja su zasad slobodna
         * (slobodan-termin=0)-> uzimamo random 2 broja koji će nam označavati 
         * određeno polje, ovisno o tome jeli na tom polju već broj ili nije
         * polje će se popuniti određenim brojem (vidi legendu)
         * Riješen constraint da se neki ispiti istog razreda pišu dva puta 
         */
       while(count<6){
            while(true){
                zastavica=0;
                number1=r.nextInt(2);
                number2=r.nextInt(4);
                number3=r.nextInt(7);
                //na početku su svi elementi polja inicijalizirani na nulu, tj. 
                //svi termini su slobodni, za slučaj da se generira nula u 
                //number 3 izbrisat ćemo ju dodavanjem sljedećeg uvjeta
                if (number3==0)
                    number3=1;
                for(int i=0;i<6;i++){
                    if(number3==spremnik[i]){
                        zastavica=1;
                        break;
                    }
                }
                //ako je zastavica u jedinici znači da je ovaj razred/ispit već 
                //dobio termin i učionicu,
                //vratit će se u petlju i generirati novi, a ovaj će zanemariti
                if(zastavica==1)
                    ;
                //ako je taj termin/učionica popunjen nećemo ga prebrisati 
                //novim brojem
                else if (raspored[number1][number2]!=0)
                    ;
                //inače popuni termin, i stavi pospremi kombinaciju razreda/
                //ispita u polje spremnik da se zna da je odabrana 
                else{
                    raspored[number1][number2]=number3;
                    spremnik[count]=number3;
                    count++;
                    break;
                }
            }
       }
    }
               
    
    //dohvaćanje rasporeda
    public void getRaspored(){
         for(int i=0;i<2;i++){
            for(int j=0;j<4;j++){
               System.out.print(raspored[i][j]);
            }
            System.out.println(" ");
        }        
    }
    
    StringBuffer getRasp(){       
        for(int i=0;i<2;i++){
            for(int j=0;j<4;j++){
                rasp.append(String.valueOf(raspored[i][j]));
            }
            rasp.append(newline);
        }
        return rasp;
    }
    
    public void calculateFitness(){
        /*Inicijaliziramo polje spremnik, 0. element polja će brojati koflikte
         * termina prvog razreda, 1. element če brojati konlikte 2. razreda
         * ---vezano za ograničenje da rzred ne smije pisati dva ispita u jednom 
         * danu 
         */
        
        int spremnik[]=new int[2];
        
        for(int i=0;i<4;i++){
            /* računamo koliko razreda je smješteno u učionice u koje ne stanu
            *  drugi red predstavlja učionicu kapaciteta 25
            *  ako u tu učionicu bude smješten razred od 30 povećamao konfliktUčionica
            *  koji ćemo iskoristiti u računanju fitnesa
            */
            if(raspored[1][i]==1 || raspored[1][i]==2 || raspored[1][i]==3)
                kofliktUcionica++;
        }
        //provjera po stupcima(terminima)
        for(int j=0;j<4;j++){
            //za svaki termin krećemo iznova gledati konflikte 
            spremnik[0]=0;
            spremnik[1]=0;
            //provjera po retcima(učionicama)
            for(int i=0;i<2;i++){
                
                if(raspored[i][j]==1 || raspored[i][j]==2 ||raspored[i][j]==3)
                    if(spremnik[0]!=0)
                        spremnik[0]++;
                    else
                        spremnik[0]=1;
                else if(raspored[i][j]==4 || raspored[i][j]==5 || raspored[i][j]==6)
                    if(spremnik[1]!=0){
                        spremnik[1]++;
                    }
                    else 
                        spremnik[1]=1;
            }
            if(spremnik[0]>1){
                kofliktTermin+= spremnik[0]-1;
            }
            if(spremnik[1]>1)
                kofliktTermin+= spremnik[1]-1;
        }
        fitness = 1./(1+kofliktUcionica+kofliktTermin);
    }         
    public void getKonlfiktTermin(){
        System.out.println("KofliktTermin: " + kofliktTermin);
    }
    public void getKonfliktUcionica(){
        System.out.println("KonfliktUcionica:" + kofliktUcionica);
    }
    public void getFitness(){
        System.out.println("Fitnes kromosoma" + fitness);
    }
    
    StringBuffer getKonfliktUcGUI(){
        rasp.append(newline + "Konflikti učionica: " + kofliktUcionica);
        return rasp;
    }
    
    StringBuffer getKonfliktTerGUI(){
        rasp.append(newline + "Konflikti termina: " + kofliktTermin);
        return rasp;
    }
    
    String getFitnessGUI(){
        return String.valueOf(fitness);
    }


}
    